2011-12-01  Werner Koch  <wk@g10code.com>

	NB: ChangeLog files are no longer manually maintained.  Starting
	on December 1st, 2011 we put change information only in the GIT
	commit log, and generate a top-level ChangeLog file from logs at
	"make dist".  See doc/HACKING for details.

2011-11-30  Werner Koch  <wk@gnupg.org>

        Rewrite dns-cert.c to not use the gpg-only iobuf stuff.
        * dns-cert.c: Remove iobuf.h.
        (get_dns_cert): Rename to _get_dns_cert.  Remove MAX_SIZE arg.
	Change iobuf arg to a estream-t.  Rewrite function to make use of
	estream instead of iobuf.  Require all parameters.  Return an
	gpg_error_t error instead of the type.  Add arg ERRSOURCE.
        * dns-cert.h (get_dns_cert): New macro to pass the error source to
	_gpg_dns_cert.
        * t-dns-cert.c (main): Adjust for changes in get_dns_cert.

        * estream.c (es_fopenmem_init): New.
	* estream.h (es_fopenmem_init): New.

2011-11-29  Werner Koch  <wk@g10code.com>

	* estream.c (func_mem_create): Don't set FUNC_REALLOC if GROW is
	not set.  Require FUNC_REALLOC if DATA is NULL and FUNC_FREE is
	given.

	* dns-cert.c: Use new CERTTYPE_ constants for better readability.

2011-11-28  Werner Koch  <wk@g10code.com>

	* t-dns-cert.c (main): Increase MAX_SIZE to 64k.

	* dns-cert.c (get_dns_cert): Factor test code out to ...
	* t-dns-cert.c: new file.

2011-10-24  Werner Koch  <wk@g10code.com>

	* dotlock.h, dotlock.c: Add alternative to allow distribution of
	these files under a modified BSD license

2011-09-30  Werner Koch  <wk@g10code.com>

	Change the license of all JNLIB parts from LPGLv3+ to to LGPLv3+
	or GPLv2+.

	* dotlock.h (DOTLOCK_EXT_SYM_PREFIX): New macro.

2011-09-29  Werner Koch  <wk@g10code.com>

	* dotlock.c (DOTLOCK_USE_PTHREAD): New macro.
	[DOTLOCK_USE_PTHREAD] (all_lockfiles_mutex): New.
	(LOCK_all_lockfiles, UNLOCK_all_lockfiles): New.  Use them to
	protect access to all_lockfiles.
	(dotlock_set_fd, dotlock_get_fd): New.

2011-09-28  Werner Koch  <wk@g10code.com>

	* dotlock.c (dotlock_take, dotlock_take_unix, dotlock_take_w32):
	Implement arbitrary timeout values.
	(dotlock_create): Add arg FLAGS for future extensions.

2011-09-27  Werner Koch  <wk@g10code.com>

	* dotlock.c (dotlock_take_unix): Check only the link count and not
	the error return from link.
	(use_hardlinks_p): New.
	(dotlock_create_unix): Test for hardlinks.
	(dotlock_take_unix): Implement O_EXCL locking.

2011-09-23  Werner Koch  <wk@g10code.com>

	* dotlock.c: Factor Unix and W32 specific code out into specific
	functions.  Define HAVE_POSIX_SYSTEM.  Rearrange some functions.
	(disable_dotlock): Rename to dotlock_disable.
	(create_dotlock): Rename to dotlock_create.
	(destroy_dotlock): Rename to dotlock_destroy.
	(make_dotlock): Rename to dotlock_take.
	(release_dotlock): Rename to dotlock_release.

2011-09-22  Werner Koch  <wk@g10code.com>

	* dotlock.c: Remove support for RISCOS.

2011-08-10  Werner Koch  <wk@g10code.com>

	* t-exechelp.c (test_close_all_fds): Don't use the DUMMY_FD var.

	* pka.c (get_pka_info): Remove unused var.

	* signal.c (got_fatal_signal): Remove unused var.

	* estream.c (es_fread, es_fwrite): Remove unused var.

2011-07-20  Werner Koch  <wk@g10code.com>

	* ssh-utils.c, ssh-utils.h: New.
	* t-ssh-utils.c: New.
	* Makefile.am (t_ssh_utils_LDADD): New.
	(module_tests): Add t-ssh-utils.c

2011-06-01  Marcus Brinkmann  <mb@g10code.com>

	* util.h: Undef snprintf before redefining it.

2011-05-20  Werner Koch  <wk@g10code.com>

	* util.h: Remove some error code substitutes.

2011-04-25  Werner Koch  <wk@g10code.com>

	* userids.c (classify_user_id): Add arg OPENPGP_HACK to fix
	regression from 2009-12-08.

2011-04-01  Werner Koch  <wk@g10code.com>

	* sysutils.c (get_uint_nonce): New.

2011-03-03  Werner Koch  <wk@g10code.com>

	* estream.c (struct estream_list): Rename to estream_list_s and
	simplify.  A double linked list is overkill for our purpose.
	(do_list_add, do_list_remove): Adjust accordingly.
	(_es_get_std_stream): Ditto.
	(do_list_iterate, estream_iterator_t): Remove; it is used only at
	one place.
	(es_fflush): Replace iteration function.  Also lock each stream
	while flushing all streams.

2011-02-27  Werner Koch  <wk@g10code.com>

	* gettime.c (isotime2epoch): Factor check code out to ..
	(isotime_p): .. new.
	(isotime_human_p): New.
	(string2isotime): New.
	* t-gettime.c (test_string2isotime): New.

2011-02-11  Andrey Jivsov <openpgp@brainhub.org>

	* openpgp-oid.c (openpgp_oid_to_str): Use unsigned int for
	get_opaque.  Fixes a bug on 64 bit platforms.

2011-02-08  Werner Koch  <wk@g10code.com>

	* http.c (connect_server): Add arg R_HOST_NOT_FOUND.

2011-02-07  Werner Koch  <wk@g10code.com>

	* http.c (my_socket_new, my_socket_ref, my_socket_unref): New.
	(cookie_close, cookie_read, cookie_write, http_close, _http_open)
	(send_request): Replace use of an socket integer by the new socket
	object.
	(_http_raw_connect): New.
	(fp_onclose_notification): New.
	(_http_raw_connect, _http_wait_response, http_close): Register and
	unregister this notification.
	* http.h (http_raw_connect): New.

	* http.h (parsed_uri_s): Add field IS_OPAQUE.
	(http_req_t): Add HTTP_REQ_OPAQUE.
	* http.c (do_parse_uri): Parse unknown schemes into PATH.
	(my_socket_new, my_socket_ref, my_socket_unref): New.
	(send_request): Simplify save_errno stuff.

2011-02-03  Werner Koch  <wk@g10code.com>

	* status.h (STATUS_DECRYPTION_INFO): New.

	* argparse.c (strusage): Update copyright year.

2011-01-31  Werner Koch  <wk@g10code.com>

	* openpgp-oid.c: New.
	* t-openpgp-oid.c: New.

2011-01-20  Werner Koch  <wk@g10code.com>

	Fix bug#1313.

	* http.c (my_select): New.  Define to pth_select if building with Pth.
	(start_server, write_server, cookie_read, cookie_write): Use it.
	(my_connect): New.  Define to pth_connect if building with Pth.
	(connect_server): Use it.
	(my_accept): New.  Define to pth_accept if building with Pth.
	(start_server): Use it.

2011-01-20  Werner Koch  <wk@g10code.com>

	* util.h (struct b64state): Add field LASTERR.
	* b64enc.c (enc_start, b64enc_write, b64enc_finish): Handle
	LASTERR.  This is to make sure that we don't leak strduped data.
	* b64dec.c (b64dec_start, b64dec_proc, b64dec_finish): Ditto.

	* http.c (escape_data): New.
	(insert_escapes): Implement using escape_data.
	(http_escape_data): New.

2011-01-19  Werner Koch  <wk@g10code.com>

	* homedir.c (gnupg_module_name): Use NAME_OF_INSTALLED_GPG instead
	of "gpg2".

2011-01-18  Werner Koch  <wk@g10code.com>

	* iobuf.c (file_es_filter_ctx_t): New.
	(file_es_filter): New.
	(iobuf_esopen): New.

	* membuf.c (clear_membuf, peek_membuf): New.

	* util.h (GPG_ERR_NO_KEYSERVER): New.

	* keyserver.h (keyserver_spec): Move from ../g10/options.h to here.

	* http.c (do_parse_uri): Add arg NO_SCHEME_CHECK.  Change all
	callers.  Support HKP and HKPS.
	(_http_parse_uri): Do proper error management.
	* http.h (parsed_uri_s): Add field IS_HTTP.
	(http_parse_uri): Support NO_SCHEME_CHECK arg.

	* estream.c (es_func_mem_write): Fix computation of NEWSIZE.

2011-01-10  Werner Koch  <wk@g10code.com>

	* session-env.c (update_var): Fix same value detection.  Fixes
	bug#1311.

2010-12-17  Werner Koch  <wk@g10code.com>

	* asshelp.c (lock_spawning): Add arg VERBOSE.  Improve timeout
	management.  Make callers pass a value for VERBOSE.
	(lock_agent_spawning, unlock_agent_spawning): Remove.  Change
	callers to use lock_spawning and unlock_spawning.

2010-12-17  Marcus Brinkmann  <mb@g10code.com>

	* homedir.c (gnupg_cachedir): Create /temp subdirectories.

2010-12-02  Werner Koch  <wk@g10code.com>

	* miscellaneous.c (gnupg_cipher_algo_name): New.  Replace all
	users of gcry_cipher_algo_name by this one.

	* logging.c (fun_cookie_s) [W32CE]: Add field USE_WRITEFILE.
	(fun_writer) [W32CE]: Make use of it.
	(set_file_fd) [W32CE]: Implement special filename "GPG2:".

2010-11-25  Werner Koch  <wk@g10code.com>

	* asshelp.c (start_new_gpg_agent): Change style of startup info.
	(start_new_dirmngr): Ditto.

2010-11-23  Werner Koch  <wk@g10code.com>

	* asshelp.c (SECS_TO_WAIT_FOR_AGENT, SECS_TO_WAIT_FOR_DIRMNGR):
	Use these constants.  For W32CE increase them to 30 seconds.
	(start_new_gpg_agent): Print time to startup agent.
	(start_new_dirmngr): Ditto.

2010-11-04  Werner Koch  <wk@g10code.com>

	* logging.c (do_logv) [W32]: Don't set a default log stream if the
	registry entry is empty.

2010-10-27  Werner Koch  <wk@g10code.com>

	* gettime.c (gnupg_get_isotime): Compare to (time_t)-1.
	(epoch2isotime): Ditto.
	(IS_INVALID_TIME_T): New.
	(asctimestamp): Use new macro.
	(strtimestamp, isotimestamp): Ditto.  Use snprintf.

2010-10-25  Werner Koch  <wk@g10code.com>

	* logging.c (do_log): Rename to log_log and make global.

2010-10-20  Werner Koch  <wk@g10code.com>

	* i18n.c (i18n_init) [USE_SIMPLE_GETTEXT]: Call textdomain.

2010-10-14  Werner Koch  <wk@g10code.com>

	* asshelp.c (start_new_gpg_agent): Print a notice once the agent
	has been started.
	(start_new_dirmngr): Likewise.

2010-10-13  Werner Koch  <wk@g10code.com>

	* miscellaneous.c (parse_version_number, parse_version_string)
	(gnupg_compare_version): New.

2010-10-04  Werner Koch  <wk@g10code.com>

	* gettime.c (asctimestamp) [W32CE]: Do not print the timezone.

2010-09-30  Werner Koch  <wk@g10code.com>

	* util.h (GPG_ERR_FULLY_CANCELED): Add replacement.

2010-09-17  Werner Koch  <wk@g10code.com>

	* http.c (INADDR_NONE): Provide fallback.
	* logging.c (INADDR_NONE): Ditto.

2010-09-16  Werner Koch  <wk@g10code.com>

	* util.h: Add GPG_ERR_MISSING_ISSUER_CERT.
	* status.c (get_inv_recpsgnr_code): Ditto.

2010-09-13  Werner Koch  <wk@g10code.com>

	* homedir.c (gnupg_bindir) [W32CE]: Change to bin/.
	(gnupg_libexecdir) [W32]: Call gnupg_bindir.
	(gnupg_libdir, gnupg_datadir, gnupg_localedir) [W32]: Simplify by
	using xstrconcat.
	(gnupg_module_name): Ditto.
	(w32_rootdir): Strip a trailing "bin".

2010-09-02  Werner Koch  <wk@g10code.com>

	* util.h (GPG_ERR_NOT_INITIALIZED): Define if not defined.

2010-09-01  Marcus Brinkmann  <marcus@g10code.de>

	* estream.c (_es_set_std_fd): Disable debug output.

2010-08-26  Werner Koch  <wk@g10code.com>

	* estream.c (es_convert_mode): Rename to parse_mode.
	(parse_mode): Add arg R_CMODE and parse key value pairs.  Use Use
	664 as the default mode.  Change callers.
	(ES_DEFAULT_OPEN_MODE): Remove.
	(es_fopen, do_fpopen, do_w32open, es_freopen): Support a creation
	mode.
	(es_func_file_create): Rename to func_file_create and add arg CMODE.
	(es_func_fd_create): Rename to func_fd_create.
	(es_func_fp_create): Rename to func_fp_create.
	(es_list_add): Rename to do_list_add.
	(es_list_remove): Rename to do_list_remove.
	(es_list_iterate): Rename to do_list_iterate.
	(es_pth_read): Rename to do_pth_read.
	(es_deinit): Rename to do_deinit.
	(es_init_do): Rename to do_init.
	(es_func_mem_create): Rename to func_mem_create.

2010-08-23  Werner Koch  <wk@g10code.com>

	* exechelp-w32ce.c: Rewrite all spawn stuff.

	* exechelp-w32.c (close_all_fds) [W32]: Make it a dummy function.

	* estream.c (es_onclose): New.
	(notify_list_t, onclose): New.
	(struct estream_internal): Add field ONCLOSE.
	(es_initialize, es_deinitialize): Manage new field.
	(do_close): Call onclose notify functions.

2010-08-20  Werner Koch  <wk@g10code.com>

	* exechelp-w32.c (create_inheritable_pipe): Change arg to HANDLE.

	* estream.h (es_sysopen_t): New.
	* estream.c (es_func_w32_create, es_func_w32_read)
	(es_func_w32_write, es_func_w32_seek, es_func_w32_destroy)
	(estream_functions_w32, estream_cookie_fd): New.  Only for W32.
	(es_sysopen, es_sysopen_nc): New.
	(do_w32open, do_sysopen): New.
	(es_syshd, es_syshd_unlocked): New.
	(struct estream_internal): Replace filed FD by SYSHD.
	(es_initialize): Clear SYSHD_VALID.
	(map_w32_to_errno): New.
	(es_get_fd): Remove.
	(es_fileno_unlocked): Re-implement using es_syshd.
	(es_initialize, es_create): Replace arg FD by SYSHD.
	(es_fopen, es_mopen, es_fopenmem, do_fdopen, do_fpopen)
	(es_tmpfile): Use SYSHD instead of FD.
	(es_destroy): Rename to do_close.

2010-08-19  Werner Koch  <wk@g10code.com>

	* exechelp-posix.c (create_pipe_and_estream): New.
	(gnupg_spawn_process): Rework this function and its calling
	convention; it is not used anyway.
	* exechelp-w32.c (gnupg_spawn_process): Ditto.

2010-08-18  Werner Koch  <wk@g10code.com>

	* logging.c (writen): Add arg IS_SOCKET.
	(fun_writer): Pass the is_socket flag.
	(do_logv) [W32]: Allow for a default log stream

	* estream.c (struct estream_internal): Remove obsolete fields
	PRINT_FP, PRINT_ERRNO, PRINT_ERR and all remaining code cruft.

2010-08-16  Werner Koch  <wk@g10code.com>

	* estream.c (es_printf_unlocked, es_printf): New.

	* asshelp.c (lock_agent_t): Rename to lock_spawn_t.
	(lock_agent_spawning, unlock_agent_spawning): Factor code out to ...
	(lock_spawning, unlock_spawning): .. new.
	(start_new_gpg_agent): Make more use of ERRSOURCE.
	(start_new_dirmngr): New.

2010-08-13  Werner Koch  <wk@g10code.com>

	* Makefile.am (audit-events.h, status-codes.h): Fix srcdir problem
	amd depend on Makefile.am instead of Makefile.

2010-08-12  Werner Koch  <wk@g10code.com>

	* sysutils.c (gnupg_remove) [W32CE]: Fix returned error.

2010-08-09  Werner Koch  <wk@g10code.com>

	* logging.c (WITH_IPV6): New macro.
	(parse_portno): New.  From libassuan.
	(fun_writer): Support TCP logging on all platforms.
	(sock_close): New.

2010-08-06  Werner Koch  <wk@g10code.com>

	* homedir.c (dirmngr_socket_name) [W32CE]: Base on default homedir.
	(gnupg_cachedir) [W32CE]: Drop drive letter.

	* http.c (http_open_document): Rename to _http_open_document and
	add arg ERRSOURCE.  Pass ERRSOURCE to all called funcs.
	(http_wait_response, http_open, http_parse_uri): Likewise.
	(do_parse_uri, parse_response, store_header): Change to return an
	gpg_err_code_t.  Change callers.
	(send_request): Add arg ERRSOURCE.  Change callers.
	* http.h (http_open_document, http_wait_response, http_open)
	(http_parse_uri): Define as macro.

2010-08-05  Werner Koch  <wk@g10code.com>

	* estream.h (es_asprintf, es_vasprintf): Add lost prototyps.

	* http.c: Require estream and make HTTP_USE_ESTREAM obsolete.  It
	make the code unreadable and we require estream anyway for GnuPG.
	(http_wait_response): Get use of cookies right.
	(send_request): s/xtryasprintf/es_asprintf/ to allow standalone
	use of the code.
	(insert_escapes, connect_server): s/sprintf/snprintf/.
	(parse_response): s/my_read_line/es_read_line/.
	(my_read_line): Remove.
	(write_server): Use pth_write.

2010-07-26  Werner Koch  <wk@g10code.com>

	* estream.c (es_func_fp_write) [W32]: Write smaller chunks.

2010-07-25  Werner Koch  <wk@g10code.com>

	* argparse.c (initialize): Use ARGPARSE_PRINT_WARNING constant.

2010-07-24  Werner Koch  <wk@g10code.com>

	* estream.c (es_set_binary): New.

2010-07-19  Werner Koch  <wk@g10code.com>

	* utf8conv.c (utf8_to_wchar): s/malloc/jnlib_malloc/.

2010-07-16  Werner Koch  <wk@g10code.com>

	* http.h (HTTP_FLAG_IGNORE_CL): Add flag .
	* http.c (WITHOUT_GNU_PTH): Test macro for Pth support.
	(http_parse_uri): s/xcalloc/xtrycalloc/.
	(send_request): Replace of discrete allocation and sprintf by
	xtryasprintf.
	(http_wait_response): Replace HTTP_FLAG_NO_SHUTDOWN by
	HTTP_FLAG_SHUTDOWN to change the default to no shutdown.
	(cookie_read) [HAVE_PTH]: Use pth_read.
	(longcounter_t): New.
	(struct cookie_s): Add support for content length.  Turn flag
	fields into bit types.
	(parse_response): Parse content length header.
	(cookie_read): Take care of the content length.

2010-07-08  Werner Koch  <wk@g10code.com>

	* estream.c (estream_functions_file): Remove and replace by
	identical estream_functions_fd.

2010-07-06  Werner Koch  <wk@g10code.com>

	* util.h (b64state): Add field STREAM.
	* b64enc.c (b64enc_start): Factor code out to ..
	(enc_start): new.
	(b64enc_start_es, my_fputs): New.
	(b64enc_write, b64enc_finish): Support estream.

2010-06-24  Werner Koch  <wk@g10code.com>

	* asshelp.c (lock_agent_spawning) [W32]: Use CreateMutexW.
	(start_new_gpg_agent): Use HANG option for gnupg_wait_progress.
	Fixes regression from 2010-06-09.

2010-06-21  Werner Koch  <wk@g10code.com>

	* util.h (xfree_fnc): New.

2010-06-18  Werner Koch  <wk@g10code.com>

	* util.h (GPG_ERR_MISSING_KEY) [!GPG_ERR_MISSING_KEY]: New.

	* sexputil.c (make_canon_sexp_pad): Add arg SECURE.

2010-06-17  Werner Koch  <wk@g10code.com>

	* sexputil.c (make_canon_sexp_pad): New.

2010-06-14  Werner Koch  <wk@g10code.com>

	* membuf.c (put_membuf): Add shortcut for !LEN.

2010-06-11  Marcus Brinkmann  <marcus@g10code.de>

	* sysutils.c (translate_sys2libc_fd): Revert last change.
	(translate_sys2libc_fd_int): Revert last change.

2010-06-10  Marcus Brinkmann  <marcus@g10code.de>

	* sysutils.c (translate_sys2libc_fd) [HAVE_W32CE_SYSTEM]:
	Implement.
	(translate_sys2libc_fd_int) [HAVE_W32CE_SYSTEM]: Don't call
	translate_sys2libc_fd.

	* estream.c (_es_get_std_stream): Fix cut&paste bug.

2010-06-09  Werner Koch  <wk@g10code.com>

	* exechelp-posix.c, exechelp-w32.c
	* exechelp-w32ce.c (gnupg_wait_process): Add new arg HANG.  Change
	all callers.
	(gnupg_release_process): New.  Use it after all calls to
	gnupg_wait_process.

	* util.h (GNUPG_MODULE_NAME_DIRMNGR_LDAP): New.
	* homedir.c (gnupg_cachedir): New.
	(w32_try_mkdir): New.
	(dirmngr_socket_name): Change standard socket name.
	(gnupg_module_name): Support GNUPG_MODULE_NAME_DIRMNGR_LDAP.

	* logging.c (log_set_get_tid_callback): Replace by ...
	(log_set_pid_suffix_cb): .. new.
	(do_logv): Change accordingly.

2010-06-08  Marcus Brinkmann  <marcus@g10code.de>

	* Makefile.am (AM_CFLAGS): Add $(LIBASSUAN_CFLAGS).
	(t_common_ldadd): Add $(LIBASSUAN_LIBS).
	* sysutils.c: Include <assuan.h>.
	(translate_sys2libc_fd_int): Cast to silence gcc warning.
	* iobuf.c: Include <assuan.h>
	(translate_file_handle): Fix syntax error.

2010-06-08  Werner Koch  <wk@g10code.com>

	* iobuf.c (translate_file_handle) [W32CE]: Handle rendezvous ids.

2010-06-07  Werner Koch  <wk@g10code.com>

	* sysutils.c [W32CE]: Finish pipe creation.

	* estream.c (es_fname_get, es_fname_set): New.
	(fname_set_internal): New.
	(struct estream_internal): Add fields printable_fname and
	printable_fname_inuse.
	(_es_get_std_stream): Set stream name.
	(es_fopen, es_freopen, es_deinitialize): Set fname.

	* exechelp-posix.c (gnupg_spawn_process): Allow passing INFILE or
	OUTFILE as NULL.
	* exechelp-w32.c (gnupg_spawn_process): Ditto.
	* exechelp-w32ce.c (gnupg_spawn_process): Return an error for
	INFILE or OUTFILE passed as NULL.

2010-06-01  Werner Koch  <wk@g10code.com>

	* logging.c (log_get_stream): Make sture a log stream is available.

2010-05-30  Werner Koch  <wk@g10code.com>

	* init.c (writestring_via_estream): New.
	(init_common_subsystems): Register with argparse.

	* argparse.c (argparse_register_outfnc): New.
	(writestrings, flushstrings): New.  Use them instead of stdout or
	stderr based functions.

2010-05-04  Werner Koch  <wk@g10code.com>

	* estream.c (_es_get_std_stream): Re-use registered standard fds.
	(IS_INVALID_FD, ESTREAM_SYS_YIELD): New.
	(es_func_fd_read, es_func_fd_write, es_func_fd_seek)
	(es_func_fd_destroy): Implement a dummy stream.

	* exechelp-w32ce.c (build_w32_commandline): Add args FD0_ISNULL
	and FD1_ISNULL.  Remove arg PGMNAME.  Change callers.
	(gnupg_spawn_process_detached): Implement.
	(gnupg_spawn_process_fd): Implement one special case for now.

2010-05-03  Werner Koch  <wk@g10code.com>

	* asshelp.c (lock_agent_spawning, unlock_agent_spawning): New.
	(start_new_gpg_agent): Test for configured standard socket and
	try to fire up the agent in this case.

	* exechelp-posix.c (gnupg_wait_process): Do not log a message if
	EXITCODE is given.
	(gnupg_spawn_process_detached): Do not reuse PID for the second fork.

2010-04-26  Werner Koch  <wk@g10code.com>

	* utf8conv.c (load_libiconv) [W32CE]: No libiconv warning

	* init.c (init_common_subsystems) [W32CE]: Register the sleep
	function before es_init.

2010-04-20  Werner Koch  <wk@g10code.com>

	* estream.c (es_deinit): New.
	(es_init_do): Install atexit handler to flush all streams.

	* Makefile.am (common_sources): Add gettime.h.

2010-04-20  Marcus Brinkmann  <marcus@g10code.de>

	* logging.c (do_log_ignore_arg): New helper function.
	(log_string): Use it to remove ugly volatile hack that causes gcc
	warning.
	(log_flush): Likewise.
	* sysutils.c (gnupg_unsetenv) [!HAVE_W32CE_SYSTEM]: Return something.
	(gnupg_setenv) [!HAVE_W32CE_SYSTEM]: Likewise.
	* pka.c (get_pka_info): Solve strict aliasing rule violation.
	* t-exechelp.c (test_close_all_fds): Use dummy variables to
	silence gcc warning.

2010-04-15  Werner Koch  <wk@g10code.com>

	* util.h: Factor time related functions out to ...
	* gettime.h: New.
	(gnupg_copy_time): Move to ...
	* gettime.c (gnupg_copy_time): New.

	* sysutils.c (gnupg_setenv) [!W32CE]: Add missing return.
	(gnupg_unsetenv) [!W32CE]: Add missing return.

2010-04-14  Werner Koch  <wk@g10code.com>

	* Makefile.am (noinst_LIBRARIES) [W32CE]: Exclude libsimple-pwquery.

	* w32help.h (umask) [W32CE]: New.

	* sysutils.c (_gnupg_isatty): New.
	* util.h (gnupg_isatty): New.

	* asshelp.c (setup_libassuan_logging): Read ASSUAN_DEBUG envvar.
	(my_libassuan_log_handler): Use it.
	* sysutils.c (_gnupg_getenv): Implement ASSUAN_DEBUG.

2010-04-08  Werner Koch  <wk@g10code.com>

	* w32help.h (_setmode, setmode) [W32CE]: Provide prototype and
	macro.

2010-04-07  Werner Koch  <wk@g10code.com>

	* mischelp.c (timegm): Replace unsetenv/putenv by gnupg_unsetenv.

	* sysutils.c: Include setenv.h.
	(gnupg_setenv, gnupg_unsetenv): New.


2010-04-06  Werner Koch  <wk@g10code.com>

	* sysutils.c (gnupg_mkdir): New.

2010-03-29  Werner Koch  <wk@g10code.com>

	* init.c (sleep_on_exit): Change to 400ms.

2010-03-25  Werner Koch  <wk@g10code.com>

	* init.c (sleep_on_exit) [W32CE]: New.
	(init_common_subsystems): Call it.

2010-03-24  Werner Koch  <wk@g10code.com>

	* stringhelp.c (change_slashes, compare_filenames): Replace
	HAVE_DRIVE_LETTERS by HAVE_DOSISH_SYSTEM.
	(make_basename, make_dirname): Detect backslashes and drive
	letters separately.

	* dotlock.c (make_dotlock, create_dotlock, release_dotlock): Use
	LockFileEx and UnlockFileEx to support W32CE.

	* ttyio.c (USE_W32_CONSOLE): Replace all _WIN32 by this.
	(init_ttyfp) [W32CE]: Use stderr.

	* iobuf.c (FD_FOR_STDIN, FD_FOR_STDOUT) [W32CE]: Use estream.
	(translate_file_handle) [W32CE]: Remove handle translation.

2010-03-23  Werner Koch  <wk@g10code.com>

	* sysutils.c (gnupg_remove): New.

2010-03-22  Werner Koch  <wk@g10code.com>

	* exechelp-w32ce.c (build_w32_commandline): Replace by code from
	libassuan.
	(create_inheritable_pipe): Use _assuan_w32ce_prepare_pipe.
	(build_w32_commandline_copy, do_create_pipe): Remove.

	* exechelp-posix.c (gnupg_spawn_process): Change to use estream
	also for INFILE and STATUSFILE.
	* exechelp-w32.c (gnupg_spawn_process): Ditto.

2010-03-22  Werner Koch  <wk@g10code.com>

	* exechelp.c: Remove after factoring all code out to ...
	* exechelp-posix.c, exechelp-w32.c, exechelp-w32ce.c:  .. new.

	* exechelp.c (create_inheritable_pipe_r)
	(create_inheritable_pipe_w): Fold both into ...
	(create_inheritable_pipe): .. New.  Change callers to use this.
	(gnupg_create_inbound_pipe, gnupg_create_outbound_pipe): Factor
	code out to ...
	(do_create_pipe): .. New.

	* init.c (parse_std_file_handles): Change to use rendezvous ids.

2010-03-15  Werner Koch  <wk@g10code.com>

	* init.c (init_common_subsystems): Add args ARGCP and
	ARGVP.  Change all callers to provide them.
	(parse_std_file_handles): New.

	* t-sysutils.c (rewind) [W32CE]: Provide a replacement.

	* Makefile.am (module_tests) [W32CE]: Don't build t-exechelp for now.

	* sysutils.c (gnupg_allow_set_foregound_window) [W32CE]: Don't
	call AllowSetForegroundWindow.

	* logging.c (isatty) [W32CE]: New.
	(fun_writer, set_file_fd): Use estream even for the internal error
	messages.
	(log_string, log_flush): Make DUMMY_ARG_PTR static.

2010-03-15  Werner Koch  <wk@g10code.com>

	* asshelp.c (send_pinentry_environment) [!HAVE_SETLOCALE]: Do not
	define OLD_LC.
	* http.c (connect_server) [!USE_DNS_SRV]: Mark SRVTAG unused.
	* dns-cert.c (get_dns_cert) [!USE_DNS_CERT]: Mark args unused.
	* pka.c (get_pka_info): Ditto.

	* signal.c (pause_on_sigusr): Remove.  It was used in ancient gpg
	version with shared memory IPC.  Last caller removed on	2006-04-18.
	(do_block) [W32]: Mark arg unused.

	* exechelp.c (w32_open_null): Use CreateFileW.

	* init.c (init_common_subsystems): Add args ARGCP and ARGVP.
	Change all callers to pass them.

	* logging.c (S_IRGRP, S_IROTH, S_IWGRP, S_IWOTH) [W32]: New.
	(fun_writer, set_file_fd) [W32]: Disable socket code.

	* localename.c: Include gpg-error.h.

	* util.h (GPG_ERR_NOT_ENABLED): Remove this temporary definition.

2010-03-12  Werner Koch  <wk@g10code.com>

	* status.h (STATUS_ENTER): New.

	* ttyio.c (tty_fprintf): Change to use estream.

	* miscellaneous.c (print_utf8_string): Rename to print_utf8_buffer
	and change FP arg to an estream.  Change all callers.
	(print_utf8_string2): Ditto; new name is to print_utf8_buffer2.

2010-03-11  Werner Koch  <wk@g10code.com>

	* miscellaneous.c (print_string): Remove.

	* estream.c (es_setvbuf): Fix parameter check.
	(es_set_buffering): Allow a SIZE of 0.
	* asshelp.c (setup_libassuan_logging, my_libassuan_log_handler): New.
	* logging.c (do_logv): Add arg IGNORE_ARG_PTR.  Change all callers.
	(log_string): New.
	(log_flush): New.
	(set_file_fd): Simplify by using estreams es_stderr.

	* estream.h (es_stdout, es_stderr, es_stdin): New.

2010-03-10  Werner Koch  <wk@g10code.com>

	* estream.c (es_func_fp_read, es_func_fp_write, es_func_fp_seek)
	(es_func_fp_destroy): Allow a NULL FP to implement a dummy stream.
	(do_fpopen): Ditto.
	(es_vfprintf_unlocked): New.
	(es_fprintf_unlocked): Make public.
	(es_fputs_unlocked): New.

	* logging.h: Replace FILE* by estream_t.
	* logging.c: Remove USE_FUNWRITER cpp conditional because we now
	use estream.
	(my_funopen_hook_ret_t, my_funopen_hook_size_t): Replace by
	ssize_t.
	(log_get_stream): Change to return an estream_t.
	(set_file_fd): Always close the log stream because it can't be
	assigned to stderr or stdout directly.  Use a dummy estream as
	last resort log stream.
	(log_test_fd, log_get_fd): Use es_fileno.
	(log_get_stream): Assert that we have a log stream.
	(do_logv): Use estream functions and lock the output.

2010-03-10  Werner Koch  <wk@g10code.com>

	* util.h: Replace jnlib path part by common.
	(snprintf): Use the replacement macro on all platforms.

	* Makefile.am (jnlib_sources): New.
	(libcommon_a_SOURCES, libcommonpth_a_SOURCES): Add jnlib_sources.
	(jnlib_tests): New.
	(noinst_PROGRAMS, TESTS): Add jnlib_tests.
	(t_common_ldadd): Remove libjnlib.a.

	* README.jnlib, ChangeLog.jnlib, libjnlib-config.h, argparse.c
	* argparse.h, dotlock.c, dotlock.h, dynload.h, logging.c
	* logging.h, mischelp.c, mischelp.h, stringhelp.c, stringhelp.h
	* strlist.c, strlist.h, types.h, utf8conv.c, utf8conv.h
	* w32-afunix.c, w32-afunix.h, w32-reg.c, w32help.h, xmalloc.c
	* xmalloc.h, t-stringhelp.c, t-support.c, t-support.h
	* t-timestuff.c, t-w32-reg.c: Move from jnlib to here.

	* init.c: Remove "estream.h".
	* util.h: Include "estream.h".

	* xasprintf.c, ttyio.c: Remove "estream-printf.h".

2010-03-08  Werner Koch  <wk@g10code.com>

	* exechelp.c [!HAVE_SIGNAL_H]: Do not include signal.h.
	(DETACHED_PROCESS, CREATE_NEW_PROCESS_GROUP) [W32CE]: Provide stubs.

	* iobuf.h (iobuf_ioctl_t): New.  Use the new macros instead of the
	hard wired values.
	* iobuf.c (iobuf_append): Remove.
	(iobuf_fdopen): Factor code out to ...
	(do_iobuf_fdopen): ... new.
	(iobuf_fdopen_nc): New.
	(iobuf_open_fd_or_name): Implement using iobuf_fdopen_nc.

	* iobuf.c (INVALID_FD): Replace by GNUPG_INVALID_FD.
	(fp_or_fd_t): Replace by gnupg_fd_t.
	(my_fileno): Replace by the FD2INT macro.
	(FILEP_OR_FD_FOR_STDIN, FILEP_OR_FD_FOR_STDOUT): Rename to
	FD_FOR_STDIN, FD_FOR_STDOUT.
	(file_filter): Make full use of FD_FOR_STDIN.
	(USE_SETMODE): Remove.  Not needed without stdio.
	(my_fopen_ro, my_fopen): Replace unneeded macros.

	* iobuf.c [FILE_FILTER_USES_STDIO]: Remove all code.  It has not
	been used for a long time.

	* exechelp.h: Include "estream.h".

	* exechelp.c (gnupg_spawn_process): Change OUTFILE to an estream_t.

2010-03-02  Werner Koch  <wk@g10code.com>

	* estream.c, estream.h, estream-printf.c, estream-printf.h: Update
	from libestream.

2010-03-01  Werner Koch  <wk@g10code.com>

	* signal.c [!HAVE_SIGNAL_H]: Don't include signal.h.

	* iobuf.c (direct_open) [W32CE]: Make filename to wchar_t.
	(iobuf_cancel) [W32CE]: Use DeleteFile.

	* gettime.c (dump_isotime): Use "%s" to print "none".

	* homedir.c (standard_homedir) [W32CE]: Use wchar_t to create the
	directory.
	(w32_rootdir) [W32CE]: Likewise.

	* sysutils.c (translate_sys2libc_fd) [W32CE]: Add support.
	(gnupg_tmpfile) [W32CE]: Ditto.
	(_gnupg_getenv) [W32CE]: New.

	* util.h (getpid, getenv) [W32CE]: New.

	* i18n.c (i18n_switchto_utf8)
	(i18n_switchback) [USE_SIMPLE_GETTEXT]: Use new function from
	libgpg-error which supports proper restoring.

	* sysutils.c (get_session_marker): Simplified by using gcrypt.

2009-12-08  Marcus Brinkmann  <marcus@g10code.de>

	* Makefile.am (audit-events.h, status.h) [!MAINTAINER_MODE]: No
	longer include these rules if not in maintainer mode.

2009-12-08  Werner Koch  <wk@g10code.com>

	* userids.h, userids.c: New.
	(classify_user_id): Merged from similar fucntions in sm/ and g10/.

	* dns-cert.c (get_dns_cert): Add support for ADNS.

2009-12-08  Marcus Brinkmann  <marcus@g10code.de>

	* asshelp.c (start_new_gpg_agent): Convert posix FD to assuan FD.

	* asshelp.c (start_new_gpg_agent) [HAVE_W32_SYSTEM]: Add missing
	argument in assuan_socket_connect invocation.
	* iobuf.c (iobuf_open_fd_or_name): Fix type of FD in function
	declaration.

2009-12-07  Werner Koch  <wk@g10code.com>

	* pka.c (get_pka_info): Add support for ADNS.
	* src.v (getsrv): Add support for ADNS.

	* srv.c (getsrv): s/xrealloc/xtryrealloc/.

2009-12-04  Werner Koch  <wk@g10code.com>

	* Makefile.am (audit-events.h, status-codes.h): Create files in
	the source dir.  Fixes bug#1164.

2009-12-02  Werner Koch  <wk@g10code.com>

	* audit.c (proc_type_decrypt, proc_type_sign): Implemented.
	(proc_type_verify): Print hash algo infos.
	* audit.h (AUDIT_DATA_CIPHER_ALGO, AUDIT_BAD_DATA_CIPHER_ALSO)
	(AUDIT_NEW_RECP, AUDIT_DECRYPTION_RESULT, AUDIT_RECP_RESULT)
	(AUDIT_ATTR_HASH_ALGO, AUDIT_SIGNED_BY, AUDIT_SIGNING_DONE):

2009-11-05  Marcus Brinkmann  <marcus@g10code.de>

	* asshelp.c (start_new_gpg_agent): Update use of
	assuan_socket_connect and assuan_pipe_connect.

2009-11-02  Marcus Brinkmann  <marcus@g10code.de>

	* get-passphrase.c (default_inq_cb, membuf_data_cb): Change return
	type to gpg_error_t.

2009-10-28  Werner Koch  <wk@g10code.com>

	* status.h (STATUS_MOUNTPOINT): New.

2009-10-16  Marcus Brinkmann  <marcus@g10code.com>

	* Makefile.am (libcommon_a_CFLAGS): Use LIBASSUAN_CFLAGS instead
	of LIBASSUAN_PTH_CFLAGS.

2009-10-13  Werner Koch  <wk@g10code.com>

	* exechelp.c (gnupg_kill_process): New.

2009-09-29  Werner Koch  <wk@g10code.com>

	* exechelp.c (create_inheritable_pipe): Rename to
	create_inheritable_pipe_w.
	(create_inheritable_pipe_r): New.
	(gnupg_create_outbound_pipe): New.

	* iobuf.h: Include "sysutils.h"

	* iobuf.c (iobuf_open_fd_or_name): New.
	(iobuf_get_fname_nonnull): New.

2009-09-23  Marcus Brinkmann  <marcus@g10code.de>

	* asshelp.c (start_new_gpg_agent): Allocate assuan context before
	starting server.

2009-09-03  Werner Koch  <wk@g10code.com>

	Update from libestream:
	* estream-printf.c: Include stdint.h only if HAVE_STDINT_H is
	defined.
	* estream-printf.c: Remove all test code.  Use macro DEBUG instead
	of TEST for debugging.
	* estream-printf.c (pr_float): Make buffer larger for silly high
	numbers.

2009-08-11  David Shaw  <dshaw@jabberwocky.com>

	* ttyio.h, ttyio.c (tty_enable_completion): Some ifdefs around
	HAVE_LIBREADLINE to allow building when readline isn't available.

2009-08-06  Werner Koch  <wk@g10code.com>

	* status.h (STATUS_INV_SGNR, STATUS_NO_SGNR): New.
	* status.c (get_inv_recpsgnr_code): New.

2009-07-23  David Shaw  <dshaw@jabberwocky.com>

	* srv.c (getsrv): Fix type-punning warning.

2009-07-23  Werner Koch  <wk@g10code.com>

	* util.h (GPG_ERR_NOT_ENABLED): New.
	* audit.h (enum): Add AUDIT_CRL_CHECK.
	* audit.c (proc_type_verify): Show CRL check result.

2009-07-06  Werner Koch  <wk@g10code.com>

	* get-passphrase.c (struct agentargs): Add SESSION_ENV and remove
	obsolete args.
	(gnupg_prepare_get_passphrase): Ditto.

	* session-env.c, session-env.h: New.
	* t-session-env.c: New.
	* Makefile.am (common_sources, module_tests): Add them.
	* asshelp.h: Include "session-env.h"
	* asshelp.c (send_one_option): Add arg PUTENV.
	(send_pinentry_environment): Replace most args by SESSION_ENV and
	rewrite fucntion.
	(start_new_gpg_agent): Likewise.

	* t-exechelp.c (test_close_all_fds): Remove debug code.

2009-07-01  Werner Koch  <wk@g10code.com>

	* sexputil.c (get_pk_algo_from_canon_sexp): New.

2009-06-29  Werner Koch  <wk@g10code.com>

	* estream.c (BUFFER_ROUND_TO_BLOCK): Remove unused macro.
	(es_func_mem_write): Rewrite reallocation part.

	* estream.c (es_write_sanitized_utf8_buffer): Typo typo fix.

2009-06-25  Werner Koch  <wk@g10code.com>

	* estream.c (es_write_sanitized_utf8_buffer): Typo fix.

2009-06-24  Werner Koch  <wk@g10code.com>

	* estream.c (es_read_line): In the malloc error case, set
	MAX_LENGTH to 0 only if requested.
	* xreadline.c (read_line): Ditto.
	* estream.c (es_write_sanitized_utf8_buffer): Pass on error from
	es_fputs.
	* sexputil.c (get_rsa_pk_from_canon_sexp): Check for error after
	the loop.  Reported by Fabian Keil.

2009-06-22  Werner Koch  <wk@g10code.com>

	* estream.c (es_pth_read, es_pth_write) [W32]: New.
	(ESTREAM_SYS_READ, ESTREAM_SYS_WRITE) [HAVE_PTH]: Use them.

2009-06-03  Werner Koch  <wk@g10code.com>

	* estream.c (es_convert_mode): Rewrite and support the "x" flag.

2009-05-28  David Shaw  <dshaw@jabberwocky.com>

	From 1.4:

	* http.h, http.c (send_request) Pass in a STRLIST for additional
	headers.  Change all callers.

2009-05-27  David Shaw  <dshaw@jabberwocky.com>

	From 1.4:

	* http.h, http.c (send_request): Pass in srvtag and make its
	presence sufficient to turn the feature on.
	(http_open): From here.
	(http_document): And here.

	* srv.c (getsrv): Raise maximum packet size to 2048, as PACKETSZ
	is too small these days.

2009-05-22  Werner Koch  <wk@g10code.com>

	* ttyio.c (tty_cleanup_after_signal): New.

2009-05-19  Werner Koch  <wk@g10code.com>

	* simple-pwquery.c (agent_open): Use SUN_LEN
	(JNLIB_NEED_AFLOCAL): Define and include mischelp.h.

2009-05-07  Werner Koch  <wk@g10code.com>

	* sexputil.c (get_rsa_pk_from_canon_sexp): New.
	* t-sexputil.c (test_make_canon_sexp_from_rsa_pk): Extend the test.

2009-04-28  Werner Koch  <wk@g10code.com>

	* sexputil.c (make_canon_sexp_from_rsa_pk): New.
	* t-sexputil.c (test_make_canon_sexp_from_rsa_pk): New.

2009-04-01  Werner Koch  <wk@g10code.com>

	* iobuf.c: Port David's changes from 1.4:
	(fd_cache_invalidate): Pass return code from close back.
	(direct_open, iobuf_ioctl): Check that return value.
	(fd_cache_synchronize): New.
	(iobuf_ioctl): Add new sub command 4 (fsync).

	* iobuf.c (fd_cache_strcmp): New. Taken from 1.4.
	(fd_cache_invalidate, fd_cache_close, fd_cache_open):  Use it.

	* exechelp.c (gnupg_spawn_process): Implement new flag bit 6.
	* sysutils.c (gnupg_allow_set_foregound_window): Allow the use of
	ASFW_ANY.

	* membuf.c (put_membuf, get_membuf): Wipe memory on out of core.

2009-03-31  Werner Koch  <wk@g10code.com>

	* percent.c (percent_unescape, percent_plus_unescape): New.
	(percent_plus_unescape_inplace, percent_unescape_inplace): New.
	(do_plus_or_plain_unescape, count_unescape, do_unescape): New.
	(do_unescape_inplace): New.
	* t-percent.c (test_percent_plus_escape): Test percent_plus_unescape.

	* get-passphrase.c, get-passphrase.h: New.
	* Makefile.am (without_pth_sources): New.

2009-03-18  Werner Koch  <wk@g10code.com>

	* exechelp.c: Include sys/resource.h and sys/stat.h.
	(get_max_open_fds): New.
	(do_exec): Use it.
	(get_all_open_fds): New.
	(close_all_fds): New.
	(do_exec): Use close_all_fds.
	* t-exechelp.c: New.

2009-03-13  David Shaw  <dshaw@jabberwocky.com>

	* http.c (do_parse_uri): Properly handle IPv6 literal addresses as
	per RFC-2732.  Adapted from patch by Phil Pennock.

2009-03-12  Werner Koch  <wk@g10code.com>

	* gettime.c: Include i18n.h.
	(dump_isotime): New.

2009-03-06  Werner Koch  <wk@g10code.com>

	* sexputil.c (make_canon_sexp): New.

2009-03-03  Werner Koch  <wk@g10code.com>

	* exechelp.c (do_exec): Make sure that /dev/null connected FDs are
	not closed.

2009-01-19  Werner Koch  <wk@g10code.com>

	* audit.c (writeout_li): Translate a few more result strings.
	Fixes bug#970.

	* convert.c (hex2str): Fix optimization to append a nul character.

2008-12-05  Werner Koch  <wk@g10code.com>

	* percent.c, t-percent.c: New.

	* exechelp.c (gnupg_spawn_process, gnupg_spawn_process_fd)
	(gnupg_spawn_process_detached) [W32]: Remove debug output.

2008-11-20  Werner Koch  <wk@g10code.com>

	* audit.c (writeout_li): Translate OKTEXT.

2008-11-04  Werner Koch  <wk@g10code.com>

	* i18n.c (i18n_init) [USE_SIMPLE_GETTEXT]: Adjust for changed
	w32-gettext.c.
	* homedir.c (gnupg_localedir): New.

2008-10-20  Werner Koch  <wk@g10code.com>

	* http.c (http_register_tls_callback) [!HTTP_USE_GNUTLS]: Mark
	unused arg.
	* localename.c (do_nl_locale_name): Ditto.
	* audit.c (event2str): Silent gcc warning.
	* sysutils.c (translate_sys2libc_fd): Mark unused arg.
	(translate_sys2libc_fd_int): Ditto.
	* iobuf.c (translate_file_handle): Ditto.
	* asshelp.c (send_one_option): Ditto.
	* exechelp.c (gnupg_spawn_process): Ditto.
	* signal.c (got_usr_signal): Ditto
	* estream.c (es_func_fd_create) [!W32]: Ditto.
	(es_func_fp_create) [!W32]: Ditto.
	(es_write_hexstring): Ditto.
	(dummy_mutex_call_void, dummy_mutex_call_int) [HAVE_PTH]: New.
	(ESTREAM_MUTEX_LOCK, ESTREAM_MUTEX_UNLOCK, ESTREAM_MUTEX_TRYLOCK)
	(ESTREAM_MUTEX_INITIALIZE) [HAVE_PTH]: Use dummy calls so to mark
	unused arg.

2008-10-19  Werner Koch  <wk@g10code.com>

	* estream-printf.c (estream_vsnprintf): Fix return value.
	(check_snprintf): Add a new test.
	(one_test) [W32]: Disable test.

2008-10-17  Werner Koch  <wk@g10code.com>

	* util.h (snprintf) [W32]: Redefine to estream_snprintf.

2008-09-03  Werner Koch  <wk@g10code.com>

	* convert.c (hex2str): New.
	(hex2str_alloc): New.
	* t-convert.c (test_hex2str): New.

2008-08-19  Werner Koch  <wk@g10code.com>

	* iobuf.c: Avoid passing a NULL (iobuf_t)->desc to the log
	function.  Should in general never be NULL, but well.  Reported by
	M. Heneka.

2008-06-26  Werner Koch  <wk@g10code.com>

	* estream.c (es_write_sanitized): Loose check for control
	characters to better cope with utf-8.  The range 0x80..0x9f is
	nowadays not anymore accidently used for control charaters.

2008-06-25  Marcus Brinkmann  <marcus@g10code.de>

	Revert last three changes related to handle translation.
	* sysutils.c:
	(FD_TRANSLATE_MAX, fd_translate, fd_translate_len)
	(translate_table_init, translate_table_lookup): Removed.
	* iobuf.c (check_special_filename): Do not use
	translate_table_lookup.
	* sysutils.h (translate_table_init, translate_table_lookup):
	Remove prototypes.

2008-06-19  Werner Koch  <wk@g10code.com>

	* sysutils.c: Remove <ctype.h>.
	(fd_translate_max): Use macro for the size.
	(translate_table_init): Protect read against EINTR and replace
	isspace by spacep.

2008-06-18  Marcus Brinkmann  <marcus@g10code.de>

	* sysutils.c (TRANS_MAX): Bump up to 350 to be on the safe side.

	* sysutils.h (translate_table_init, translate_table_lookup): New
	prototypes.
	* sysutils.c: Include <ctype.h>.
	(FD_TRANSLATE_MAX): New macro.
	(fd_translate, fd_translate_len): New static variables.
	(translate_table_init, translate_table_lookup): New functions.
	(translate_sys2libc_fd_int): Translate file descriptor.
	* iobuf.c (check_special_filename): Translate handle values from
	special filenames.

2008-06-16  Werner Koch  <wk@g10code.com>

	* homedir.c (w32_commondir): New.
	(gnupg_sysconfdir): Use it.

2008-06-09  Werner Koch  <wk@g10code.com>

	* b64dec.c: New.

2008-06-05  Werner Koch  <wk@g10code.com>

	* util.h (gnupg_copy_time): Replace strcpy by memcpy.

2008-05-26  Werner Koch  <wk@g10code.com>

	* asshelp.c (send_one_option, send_pinentry_environment): use
	xfree and xtrystrdup.

	* i18n.c (i18n_switchto_utf8) [USE_SIMPLE_GETTEXT]: Return NULL.

	* homedir.c (gnupg_module_name): Add
	GNUPG_MODULE_NAME_CONNECT_AGENT and GNUPG_MODULE_NAME_GPGCONF.

2008-04-21  Werner Koch  <wk@g10code.com>

	* http.c (http_wait_response) [W32]: Use DuplicateHandle because
	it is a socket.
	(cookie_read) [W32]: Use recv in place of read.

2008-04-08  Werner Koch  <wk@g10code.com>

	* i18n.c (i18n_switchto_utf8, i18n_switchback)
	[USE_SIMPLE_GETTEXT]: Implement.

2008-04-07  Werner Koch  <wk@g10code.com>

	* b64enc.c (b64enc_start): Detect PGP mode.
	(b64enc_finish): Write PGP CRC.
	* util.h (struct b64state): Add field CRC.
	* t-b64.c: New.

	* pka.c (get_pka_info): Use xtrymalloc and check result.

2008-03-25  Werner Koch  <wk@g10code.com>

	* localename.c: Strip all W32 code.  Include w32help.h.
	(gnupg_messages_locale_name) [W32]: Use the gettext_localename.

2008-03-17  Werner Koch  <wk@g10code.com>

	* iobuf.c (IOBUF_BUFFER_SIZE): Actually use this macro.

	* simple-pwquery.c (agent_send_all_options): Fix last change.

2008-03-06  Werner Koch  <wk@g10code.com>

	* simple-pwquery.c (agent_send_all_options): Add support for
	XAUTHORITY and PINENTRY_USER_DATA.

2008-02-15  Marcus Brinkmann  <marcus@g10code.de>

	* exechelp.c (gnupg_spawn_process_fd): Add flag DETACHED_PROCESS
	unconditionally (required for all callers at the moment).

2008-02-14  Werner Koch  <wk@g10code.com>

	* sysutils.c (gnupg_allow_set_foregound_window): New.
	(WINVER) [W32]: Define.

2008-01-31  Werner Koch  <wk@g10code.com>

	* audit.c (audit_print_result): Make sure that the output is
	always UTF8.

2008-01-27  Werner Koch  <wk@g10code.com>

	* exechelp.c (gnupg_spawn_process): Add arg FLAGS and changed all
	callers to pass 0 for it.

2007-12-13  Werner Koch  <wk@g10code.com>

	* sexputil.c (hash_algo_from_sigval): New.
	* t-sexputil.c: New.
	* Makefile.am (module_tests): Add it.

2007-12-11  Werner Koch  <wk@g10code.com>

	* asshelp.c (send_pinentry_environment): Allow using of old
	gpg-agents not capabale of the xauthority and pinentry_user_data
	options.

2007-12-04  Werner Koch  <wk@g10code.com>

	* Makefile.am (t_helpfile_LDADD, module_maint_tests): New.
	* t-helpfile.c: New.
	* helpfile.c: New.
	* membuf.h (is_membuf_ready, MEMBUF_ZERO): New.
	* localename.c: New.  Taken from gettext with modifications as done
	for GpgOL.  Export one new function.
	* util.h (gnupg_messages_locale_name, gnupg_get_help_string): Added.

	* sysutils.c (gnupg_reopen_std): New.  Taken from ../g10/gpg.c.

2007-11-27  Werner Koch  <wk@g10code.com>

	* Makefile.am (CLEANFILES): New.

	* homedir.c (dirmngr_socket_name): Use CSIDL_WINDOWS.

2007-11-15  Werner Koch  <wk@g10code.com>

	* asshelp.c (send_pinentry_environment): Add args XAUTHORITY and
	PINENTRY_USER_DATA.
	(start_new_gpg_agent): Ditto.

2007-11-07  Werner Koch  <wk@g10code.com>

	* status.h: New.
	* errors.h: Remove.

2007-11-05  Werner Koch  <wk@g10code.com>

	* audit.c, audit.h: New.
	* Makefile.am: Add rules to build audit-events.h.
	* exaudit.awk: New.
	* mkstrtable.awk: New.  Taken from libgpg-error.

2007-10-19  Werner Koch  <wk@g10code.com>

	* i18n.c (i18n_switchto_utf8, i18n_switchback): New.

2007-10-01  Werner Koch  <wk@g10code.com>

	* sysutils.h (FD2INT, INT2FD): New.

2007-09-21  Werner Koch  <wk@g10code.com>

	* homedir.c (default_homedir): Make registry work.  Reported by
	Marc Mutz.

2007-08-29  Werner Koch  <wk@g10code.com>

	* exechelp.c (gnupg_wait_process): Add arg EXITCODE.  Changed all
	callers.
	(gnupg_create_inbound_pipe): New.
	* util.h (GNUPG_MODULE_NAME_GPGSM, GNUPG_MODULE_NAME_GPG): New.
	* homedir.c (gnupg_module_name): Add them

2007-08-28  Werner Koch  <wk@g10code.com>

	* gettime.c (check_isotime, add_isotime): New.  Originally written
	for DirMngr by me.
	(add_days_to_isotime): New.
	(date2jd, jd2date, days_per_month, days_per_year): New. Taken from
	my ancient (1988) code used in Wedit (time2.c).

2007-08-27  Werner Koch  <wk@g10code.com>

	* util.h (GNUPG_MODULE_NAME_CHECK_PATTERN): New.
	* homedir.c (gnupg_module_name): Add it.
	* exechelp.c (w32_fd_or_null) [W32]: New.
	(gnupg_spawn_process_fd): New.
	(gnupg_wait_process) [W32]: Close the handle after if the process has
	returned.

2007-08-22  Werner Koch  <wk@g10code.com>

	Updated estream from libestream.

	* estream.c (mem_malloc, mem_realloc, mem_free): New.  Use them
	instead of the ES_MEM_foo.
	* estream.c (estream_cookie_mem): Remove members DONT_FREE,
	APPEND_ZERO, PTR and SIZE.  Add MEMORY_LIMIT.  Put GROW into a new
	FLAGS struct.
	(es_func_mem_create): Remove APPEND_ZERO, DONT_FREE, PTR and
	SIZE.  Add MEMORY_LIMIT.
	(es_func_mem_write, es_func_mem_seek, es_func_mem_destroy): Revamp.
	(es_open_memstream): Change API to just take a memory limit and a
	mode argument.  Rename to ..
	(es_fopenmem): .. this.
	(HAVE_W32_SYSTEM) [_WIN32]: Define if not defined.
	(tmpfd) [W32]: Implement directly using the W32 API.
	(es_fgets): Rewrite without using doreadline.

2007-08-21  Werner Koch  <wk@g10code.com>

	* sysutils.c (gnupg_tmpfile): New.
	* t-sysutils.c: New.
	* Makefile.am (module_tests): Add t-sysutils.

2007-08-20  Werner Koch  <wk@g10code.com>

	* exechelp.c [W32]: Redefine X_OK to F_OK.

2007-08-16  Werner Koch  <wk@g10code.com>

	* Makefile.am (t_convert_DEPENDENCIES): Remove
	($(PROGRAMS)): Remove.
	(t_common_ldadd): Use libcommon.a and not the macro.

2007-08-14  Werner Koch  <wk@g10code.com>

	* homedir.c (dirmngr_socket_name): New.

2007-08-07  Werner Koch  <wk@g10code.com>

	* tlv.c, tlv.h: Move from ../scd/.
	* tlv.c (parse_sexp, parse_ber_header): Add ERRSOURCE arg and prefix
	name with a _.
	* tlv.h: Use macro to convey ERRSOURCE.

2007-08-02  Werner Koch  <wk@g10code.com>

	* gc-opt-flags.h: New.

2007-08-01  Werner Koch  <wk@g10code.com>

	* estream-printf.c (read_dummy_value): Removed as it is useless now.
	(read_values): Remove check on !vaargs which is not anymore needed
	and anyway not portable.  Reported by Peter O'Gorman.

2007-07-16  Werner Koch  <wk@g10code.com>

	* estream.c (es_func_file_create): Clear NO_CLOSE flag.

2007-07-12  Werner Koch  <wk@g10code.com>

	* sysutils.h (gnupg_fd_t): New.
	* sysutils.c (translate_sys2libc_fd): Use that type instead of int.
	(translate_sys2libc_fd_int): New.

2007-07-09  Werner Koch  <wk@g10code.com>

	* t-gettime.c (test_isotime2epoch): Use time_t and not u32.

2007-07-05  Werner Koch  <wk@g10code.com>

	* t-gettime.c: New.
	* gettime.c (isotime2epoch, epoch2isotime): New.

2007-07-04  Werner Koch  <wk@g10code.com>

	* estream.c (es_init_do): Do not throw an error if pth has already
	been initialized.

2007-06-26  Werner Koch  <wk@g10code.com>

	* Makefile.am ($(PROGRAMS)): New.

	* util.h (init_common_subsystems): Moved to ..
	* init.h: .. New.
	* util.h: Include init.h.

	* homedir.c (standard_homedir): New.
	(default_homedir) [W32]: Reimplemented in terms of
	standard_homedir.  Fixed memory leak.

2007-06-25  Werner Koch  <wk@g10code.com>

	* iobuf.c: Add more documentation and slighly restructured macro
	defintion for better readability.
	(FILEP_OR_FD): Rename to fp_or_fd_t.
	(CLOSE_CACHE): Rename to close_cache_t.

	* sysutils.c (translate_sys2libc_fd): New using the code from iobuf.c.
	* iobuf.c: Include sysutils.h.
	(iobuf_translate_file_handle): Remove.
	(translate_file_handle): Use new function.

	* estream-printf.c [TEST]: Header including fixes.
	(do_format): Do not append a trailing Nul.  This avoids spurious
	Nuls in the es_printf output.
	(estream_vsnprintf, estream_vasprintf): Take this in account.

	* estream.h (struct es__stream): Change FLAGS to a bit structure.
	(ES__FLAG_WRITING): Replace by a bit from FLAGS.  * estream.c
	(struct estream_internal): Rename FLAGS to MODEFLAGS so that they
	are not confused with the estream flags.
	(es_initialize, es_create): Add arg MODEFLAGS so that we can setup
	the intial writemode.  Changed all callers to pass them.
	(es_convert_mode): Set O_BINARY.
	(es_func_fd_create, es_func_fp_create, es_func_file_create) [W32]:
	Call setmode if requested.

2007-06-24  Werner Koch  <wk@g10code.com>

	* estream.c (do_fpopen, es_fpopen, es_fpopen_nc): New.
	(es_func_fp_create, es_func_fp_read, es_func_fp_write)
	(es_func_fp_seek, es_func_fp_destroy): New.

2007-06-22  Werner Koch  <wk@g10code.com>

	* estream.c (es_fdopen): Factored code out to..
	(do_fdopen): .. new.
	(es_fdopen_nc): New.
	(estream_cookie_fd): Add field NO_CLOSE.
	(es_func_fd_create): Add arg NO_CLOSE and changed all callers.
	(es_func_fd_destroy): Handle the new flag.

	* homedir.c (gnupg_libexecdir) [W32]: Factor code out to ..
	(w32_rootdir): .. new.
	(gnupg_sysconfdir, gnupg_libdir, gnupg_datadir) [W32]: Return
	name based on w32_rootdir().

2007-06-21  Werner Koch  <wk@g10code.com>

	* membuf.h (get_membuf_len): New.

	* membuf.c (init_membuf_secure): Really allocate in secure memory.
	(put_membuf_str): New.

	* ttyio.c (tty_getf): New.

	* util.h (ctrl_t): Declare it here.

	* asshelp.c (start_new_gpg_agent): New.  Based on code from
	../sm/call-agent.c

2007-06-20  Werner Koch  <wk@g10code.com>

	* sysutils.c (gnupg_sleep): New.
	* sysutils.h [W32]: Remove _sleep wrapper.  Changed all callers to
	use gnupg_sleep.

	* exechelp.c (build_w32_commandline_copy): New.
	(build_w32_commandline): Factored some code out to new function
	and correctly process a PGMNAME with spaces.
	(gnupg_spawn_process_detached) [W32]: Implement.

2007-06-14  Werner Koch  <wk@g10code.com>

	* simple-pwquery.h (MAP_SPWQ_ERROR_IMPL): New.
	(SPWQ_NO_PIN_ENTRY): New.
	* simple-pwquery.c (simple_pw_set_socket): New.
	(agent_open): Use it if GPG_AGENT_INFO is not set.
	(simple_pwquery): Extended to allow returning of otehyr error codes.

	* util.h (GNUPG_MODULE_NAME_AGENT, GNUPG_MODULE_NAME_PINENTRY)
	(GNUPG_MODULE_NAME_SCDAEMON, GNUPG_MODULE_NAME_DIRMNGR)
	(GNUPG_MODULE_NAME_PROTECT_TOOL): New.
	* homedir.c (gnupg_module_name): New.
	(gnupg_bindir): New.

2007-06-12  Werner Koch  <wk@g10code.com>

	* homedir.c (gnupg_sysconfdir): New.
	(gnupg_libexecdir): New.  Taken from g10/misc.c:get_libexecdir.
	(gnupg_datadir): New.
	(gnupg_libdir): New.

	* http.c (connect_server) [W32]: Do not call init_sockets if
	HTTP_NO_WSASTARTUP is defined.

	* init.c: New.

	* estream.c (es_init_do): Init stream lock here because we can't
	use a static initialization with W32pth.

2007-06-11  Werner Koch  <wk@g10code.com>

	* Makefile.am (t_common_ldadd): Use libcommonstd macro.

2007-06-06  Werner Koch  <wk@g10code.com>

	* Makefile.am: Include am/cmacros.am.

	* sysutils.h [W32]: Remove prototypes for the registry access.
	* w32reg.c:  Move to ../jnlib/w32-reg.c.

	* i18n.c (i18n_init): New.

	* simple-gettext.c: Remove.

	* iobuf.c (iobuf_get_filelength): Rename SIZE to EXSIZE to silent
	shadowing warning.

2007-06-04  Werner Koch  <wk@g10code.com>

	* http.c [W32]: Include unistd.h also in this case.
	(write_server) [W32]: Fixed error code.
	(init_sockets): Fixed syntax error.
	(cookie_close): Replace close by sock_close macro.

	* estream.c [w32]: Do not init Mutex.

	* Makefile.am (common_sources) [USE_SNS_SRV]: Build srv.c only
	when needed.

	* ttyio.c (init_ttyfp) [W32]: Do not use TTYFP.

	* util.h: Include ../jnlib/dynload.h.

	* dynload.h:  Move to ../jnlib.

2007-05-30  Werner Koch  <wk@g10code.com>

	* estream.c (MEM_FREE, MEM_ALLOC, MEM_REALLOC): Prefix with ES_ as
	windows.h also has such definitions,

2007-05-15  Werner Koch  <wk@g10code.com>

	* util.h: Do not include gnulib's vasprintf.  Redefine asprintf
	and vasprintf.

	* xasprintf.c (xasprintf, xtryasprintf): Use estream_vasprintf.

	* estream-printf.h, estream-printf.c: New.  Taken from current
	libestream SVN.
	* Makefile.am (common_sources): Add them.

2007-05-14  Werner Koch  <wk@g10code.com>

	* sexp-parse.h (smklen): New.
	* sexputil.c: Include sexp-parse.h.
	(make_simple_sexp_from_hexstr): Replace sprintf by smklen.

2007-05-07  Werner Koch  <wk@g10code.com>

	* signal.c (got_fatal_signal): Protect SIG from being clobbered by
	a faulty signal implementaion.  Suggested by James Juran.

2007-04-25  Werner Koch  <wk@g10code.com>

	* i18n.h (ngettext): New.
	* simple-gettext.c (ngettext): New.

2007-04-20  Werner Koch  <wk@g10code.com>

	* miscellaneous.c (my_gcry_logger, my_gcry_outofcore_handler):
	Moved from gpg-agent to here.
	(my_gcry_fatalerror_handler): new.
	(setup_libgcrypt_logging): New.

2007-03-19  Werner Koch  <wk@g10code.com>

	* miscellaneous.c (print_hexstring): New.
	* estream.c (es_fprintf_unlocked): New.
	(es_write_sanitized): New.
	(es_write_hexstring): New.
	(es_write_sanitized_utf8_buffer) [GNUPG_MAJOR_VERSION]: New.

2007-03-09  David Shaw  <dshaw@jabberwocky.com>

	From STABLE-BRANCH-1-4

	* http.c (do_parse_uri): Remove the hkp port 11371 detection.  We
	implement hkp in the keyserver handler, and the support here makes
	it appear like a bad hkp request actually succeeded.

2007-01-31  Werner Koch  <wk@g10code.com>

	* Makefile.am (t_common_ldadd): Add LIBINCONV and LIBINTL.

2007-01-25  Werner Koch  <wk@g10code.com>

	* simple-pwquery.c (simple_pwquery): New arg OPT_CHECK.

2006-12-13  David Shaw  <dshaw@jabberwocky.com>

	* Makefile.am (AM_CPPFLAGS): Include intl/ so we can reference the
	built-in headers.

2006-11-23  Werner Koch  <wk@g10code.com>

	* http.c: Include i18n.h

2006-11-21  Werner Koch  <wk@g10code.com>

	* estream.c: Remove explicit Pth soft mapping diabling becuase it
	is now done in config.h.

2006-11-15  Werner Koch  <wk@g10code.com>

	* estream.c: Disabled Pth soft mapping.
	(my_funopen_hook_ret_t): New.
	(print_fun_writer): Use it here.

	* iobuf.c (fd_cache_close): Use %d instead of %p for debug output.

2006-11-03  Werner Koch  <wk@g10code.com>

	* Makefile.am (t_convert_DEPENDENCIES): Add libcommon.  From
	Gentoo.

2006-10-24  Marcus Brinkmann  <marcus@g10code.de>

	* Makefile.am (libcommon_a_CFLAGS): Add $(LIBASSUAN_CFLAGS).
	(libsimple_pwquery_a_CFLAGS): New variable.

2006-10-20  Werner Koch  <wk@g10code.com>

	* convert.c (hex2bin): New.

2006-10-17  Werner Koch  <wk@g10code.com>

	* estream.c (struct estream_internal, es_initialize)
	(es_deinitialize, print_fun_writer, es_print): New and modified
	functions to avoid tempfiles for printf style printing.

	* Makefile.am (libcommonpth_a_SOURCES): New. We now build a secon
	version of the library with explicit Pth support.
	* exechelp.c, estream.c: Make use of WITHOUT_GNU_PTH.

2006-10-08  Werner Koch  <wk@g10code.com>

	* gpgrlhelp.c: Trun all functions into dummies if readline is not
	available.

2006-10-06  Werner Koch  <wk@g10code.com>

	* Makefile.am (AM_CFLAGS): Use PTH version of libassuan.

	* util.h (GNUPG_GCC_A_SENTINEL): Defined for gcc >= 4.

2006-10-04  David Shaw  <dshaw@jabberwocky.com>

	* gpgrlhelp.c: readline requires stdio.h.

2006-10-04  Werner Koch  <wk@g10code.com>

	* membuf.c (init_membuf_secure): New.
	(put_membuf): Make sure that ERRNO is set even if the underlying
	malloc code does not work properly.
	(get_membuf): Set ERRNO on error.
	(get_membuf): Allow to pass LEN as NULL.

2006-10-02  Werner Koch  <wk@g10code.com>

	* iobuf.c (iobuf_unread): Removed.  This code is not required.
	Also removed the entire unget buffer stuff.

2006-09-27  Werner Koch  <wk@g10code.com>

	* util.h: Do not include strsep.h and strpbrk.h.
	(isascii): Removed as it is now in jnlib.

	* iobuf.c (pop_filter, underflow, iobuf_close): Free the unget
	buffer.

2006-09-27  Florian Weimer <fweimer@bfk.de>  (wk)

	* iobuf.c (iobuf_unread): New.

2006-09-22  Werner Koch  <wk@g10code.com>

	* i18n.h: Changed license to an all permissive one.

	* ttyio.c (tty_get): We need to use readline too.  Added two more
	hooks.

2006-09-21  Werner Koch  <wk@g10code.com>

	* ttyio.c (tty_private_set_rl_hooks): New.
	(tty_enable_completion, tty_disable_completion): Use a hook to
	enable readline support.  Now always available.
	(tty_cleanup_rl_after_signal): New.

	* ttyio.h: Removed readline specific stuff.  Included util.h.
	* common-defs.h: New.

2006-09-15  Werner Koch  <wk@g10code.com>

	* convert.c: New.
	(hexcolon2bin): New.
	(bin2hex, bin2hexcolon, do_binhex): New.
	* t-convert.c: New

2006-09-14  Werner Koch  <wk@g10code.com>

	* util.h (out_of_core): Use new gpg_error_from_syserror function.

	* http.c (init_sockets): Changed it to require 2.2 unless it is
	build within gnupg 1 where we require 1.1 (and not anymore allow
	for 1.0).

2006-09-07  Werner Koch  <wk@g10code.com>

	* exechelp.c (gnupg_spawn_process): Factor out post fork code to ..
	(do_exec): .. new function.  Allow passing of -1 for the fds.
	(gnupg_spawn_process): Terminate gcrypt's secure memory in the child.
	(gnupg_spawn_process_detached): New.

2006-09-06  Werner Koch  <wk@g10code.com>

	* maperror.c: Removed.

	* util.h (out_of_core): New.

2006-09-04  Werner Koch  <wk@g10code.com>

	* http.c (http_get_header): New.
	(capitalize_header_name, store_header): New.
	(parse_response): Store headers away.
	(send_request): Return GPG_ERR_NOT_FOUND if connect_server failed.
	* http.h: New flag HTTP_FLAG_NEED_HEADER.

2006-08-21  Werner Koch  <wk@g10code.com>

	* Makefile.am (libcommon_a_SOURCES): Added keyserver.h

	* openpgpdefs.h: New.  Stripped from ..g10/packet.h.

2006-08-16  Werner Koch  <wk@g10code.com>

	* keyserver.h: Moved from ../include to here.

	* http.c: Include srv.h.

	* srv.c, srv.h: New. Taken from GnuPG 1.4

2006-08-14  Werner Koch  <wk@g10code.com>

	* http.h (struct http_context_s): Moved to implementation.
	* http.c (http_open): Changed call to return a context.
	(http_open_document): Ditto.
	(http_get_read_ptr, http_get_read_ptr, http_get_status_code): New.
	(do_parse_uri): Replaced strlwr by straight code to ease
	standalone use of this file.
	(http_wait_response): Removed arg STATUS_CODE as it is available
	through an accessor function. Adjusted caller.
	(http_escape_string): New.

	* estream.c (es_read_line): Renamed to ..
	(doreadline): .. this.  Changed all callers.
	(es_read_line): New.  This is theusual limited getline variabnt as
	used at several places.  Here taken and adjusted from xreadline.c
	(es_free): New.

2006-08-11  Werner Koch  <wk@g10code.com>

	* http.c: Major internal changes to optionallly support GNUTLS and
	ESTREAM.
	(http_open): Move initialization of the stream ...
	(send_request): .. here.
	(http_register_tls_callback): New.

	* estream.c (es_writen): Try to seek only is a seek function has
	been registered.

2006-08-09  Werner Koch  <wk@g10code.com>

	* http.c, http.h: New.  Taken from gnupg 1.4.5, merged with
	changes done for the Dirmngr project (by g10 Code) and cleaned up
	some stuff.
	(make_header_line): New. Change all caller to make user of the new
	* Makefile.am (libcommon_a_SOURCES): Added http.c and http.h.

2006-05-23  Werner Koch  <wk@g10code.com>

	* gettime.c (isotimestamp): New.

	* ttyio.c (tty_get_ttyname): Posixly correct usage of ctermid.

	* dns-cert.c: New.  Taken from 1.4.3's util/cert.c.
	* dns-cert.h: New.

2006-05-22  Werner Koch  <wk@g10code.com>

	* pka.c: New. Taked from 1.4.3.
	* pka.h: New.
	* Makefile.am: Added pka.

2006-05-19  Werner Koch  <wk@g10code.com>

	* yesno.c (answer_is_yes_no_default, answer_is_yes_no_quit):
	Updated from 1.4.3.
	(answer_is_okay_cancel): new.  From 1.4.3.

	* miscellaneous.c (match_multistr): New.  Taken from 1.4.3.

	* ttyio.c (tty_enable_completion, tty_disable_completion): New
	dummy functions.
	* ttyio.h: Add prototypes and stubs.

2006-04-19  Werner Koch  <wk@g10code.com>

	* iobuf.c (iobuf_get_fd): New.  Taken from 1.4.3.
	(iobuf_is_pipe_filename): New.
	(pop_filter): Made static.
	(iobuf_skip_rest): New.  Orginal patch by Florian
	Weimer.  Added new argument PARTIAL.
	(block_filter): Remove the old gpg indeterminate length mode.
	(block_filter): Properly handle a partial body stream
	that ends with a 5-byte length that happens to be zero.
	(iobuf_set_block_mode, iobuf_in_block_mode): Removed as
	superfluous.
	(iobuf_get_filelength): New arg OVERFLOW.
	(iobuf_get_filelength) [W32]: Use GetFileSizeEx if available
	* miscellaneous.c (is_file_compressed): Take care of OVERFLOW.

2006-04-18  Werner Koch  <wk@g10code.com>

	* homedir.c (w32_shgetfolderpath): New.  Taken from gpg 1.4.3.
	(default_homedir): Use it.

2005-10-08  Marcus Brinkmann  <marcus@g10code.de>

	* signal.c (get_signal_name): Check value of HAVE_DECL_SYS_SIGLIST
	instead of just if it is defined.

2005-09-28  Marcus Brinkmann  <marcus@g10code.de>

	* Makefile.am (AM_CFLAGS): Add $(LIBASSUAN_CFLAGS).

2005-07-04  Marcus Brinkmann  <marcus@g10code.de>

	* simple-pwquery.h (simple_pwclear): New prototype.
	* simple-pwquery.c (simple_pwclear): New function.

2005-06-15  Werner Koch  <wk@g10code.com>

	* miscellaneous.c (make_printable_string): Made P a void*.

	* sexputil.c (keygrip_from_canon_sexp, cmp_simple_canon_sexp):
	Fixed signed/unsigned pointer mismatch.
	(make_simple_sexp_from_hexstr): Ditto.  This is all too ugly; I
	wonder why gcc-4's default is to warn about them and forcing us to
	use cast the warning away.
	* iobuf.c (block_filter): Ditto.
	(iobuf_flush): Ditto.
	(iobuf_read_line): Ditto.
	(iobuf_read): Make BUFFER a void *.
	(iobuf_write): Make BUFFER a const void *.
	* ttyio.c (tty_print_utf8_string2): Ditto.
	* estream.c (estream_cookie_mem): Make MEMORY unsigned char*.
	(es_write): Make BUFFER a void *.
	(es_writen): Ditto.
	(es_func_fd_read, es_func_fd_write, es_func_mem_read)
	(es_func_mem_write): Ditto.
	(es_read, es_readn): Ditto.
	(es_func_mem_write): Made MEMORY_NEW an unsigned char *.
	* estream.h (es_cookie_read_function_t)
	(es_cookie_write_function_t): Changed buffer arg to void*.

2005-06-03  Werner Koch  <wk@g10code.com>

	* estream.c: Use HAVE_CONFIG_H and not USE_CONFIG_H!
	(es_func_fd_read, es_func_fd_write): Protect against EINTR.

2005-06-01  Werner Koch  <wk@g10code.com>

	* Makefile.am (AM_CPPFLAGS): Added.

	* util.h: Add some includes for gnulib.
	(ttyname, isascii): Define them inline.
	* fseeko.c, ftello.c: Removed.
	* strsep.c, mkdtemp.c: Removed.
	* ttyname.c, isascii.c: Removed.

2005-05-31  Werner Koch  <wk@g10code.com>

	* dynload.h: s/__inline__/inline/.

2005-05-13  Werner Koch  <wk@g10code.com>

	* signal.c (got_fatal_signal): Print the signal number if we can't
	get a name for it.
	(get_signal_name): Return NULL if no name is available. Fixed
	conditional for sys_siglist to the correct one.

2005-04-17  Werner Koch  <wk@g10code.com>

	* sexputil.c (cmp_simple_canon_sexp): New.
	(make_simple_sexp_from_hexstr): New.

2005-04-07  Werner Koch  <wk@g10code.com>

	* sexputil.c: New.

2005-04-11  Marcus Brinkmann  <marcus@g10code.de>

	* simple-pwquery.c (simple_pwquery): Use spwq_secure_free.

2005-03-03  Werner Koch  <wk@g10code.com>

	* Makefile.am (AM_CFLAGS): Added PTH_CFLAGS.  Noted by Kazu Yamamoto.

2005-02-25  Werner Koch  <wk@g10code.com>

	* xasprintf.c (xtryasprintf): New.

2005-01-26  Moritz Schulte  <moritz@g10code.com>

	* Makefile.am (libcommon_a_SOURCES): New source files: estream.c,
	estream.h.
	* estream.c, estream.h: New files.

2005-01-03  Werner Koch  <wk@g10code.com>

	* asshelp.c (send_pinentry_environment): Fixed changed from
	2004-12-18; cut+paste error for lc-messages.

2004-12-21  Werner Koch  <wk@g10code.com>

	* simple-pwquery.c (agent_open) [W32]: Implement for W32.
	(readline) [W32]: Use recv instead of read.
	(writen) [W32]: Use send instead of write.
	(my_stpcpy): Define a stpcpy replacement so that this file
	continues to be self-contained.
	(agent_send_all_options) [W32]: Don't call ttyname.

2004-12-21  Marcus Brinkmann  <marcus@g10code.de>

	* simple-pwquery.h (simple_query): Add prototype.
	* simple-pwquery.c (simple_query): New function.

2004-12-21  Werner Koch  <wk@g10code.com>

	* signal.c (got_fatal_signal, got_usr_signal)
	(got_fatal_signal) [DOSISH]: Don't build.
	* simple-gettext.c: Include sysutils.h

	* homedir.c: New. Use CSIDL_APPDATA for W32 as the default home
	directory.
	* Makefile.am (libcommon_a_SOURCES): Add it.
	(EXTRA_DIST): Removed mkerror and mkerrtok.

2004-12-20  Werner Koch  <wk@g10code.com>

	* sysutils.h [W32]: Define sleep.
	* util.h: Add prototype for mkdtemp.

	* membuf.c (put_membuf): Wipe out buffer after a failed realloc.

2004-12-19  Werner Koch  <wk@g10code.com>

	* maperror.c (map_assuan_err_with_source): Oops, args were swapped.

2004-12-18  Werner Koch  <wk@g10code.com>

	* maperror.c (map_assuan_err): Renamed to ..
	(map_assuan_err_with_source): .. this and add arg SOURCE.c
	* asshelp.c (send_pinentry_environment, send_one_option): Add arg
	ERRSOURCE.

2004-12-15  Werner Koch  <wk@g10code.com>

	* sysutils.h [W32]: Prototypes for registry functions.
	* w32reg.c: Include sysutils.h

	* simple-pwquery.c [W32]: Dummy code to allow a build.

	* exechelp.c [W32]: Implemented for W32 .

	* ttyname.c: New.

	* asshelp.c (send_one_option): New.
	(send_pinentry_environment): Cleaned up and made sure that empty
	values are not send.

2004-12-07  Werner Koch  <wk@g10code.com>

	* asshelp.c (send_pinentry_environment) [W32]: Do not use ttyname.

2004-12-06  Werner Koch  <wk@g10code.com>

	* exechelp.h, exechelp.c: New.  Based on code from ../sm/import.c.

2004-12-03  Werner Koch  <wk@g10code.com>

	* strsep.c: Fixed copyright comments.

2004-11-26  Werner Koch  <wk@g10code.com>

	* simple-gettext.c: New taken from gnupg 1.3.x

	* simple-pwquery.c [_WIN32]: Include winsock2.h.
	(agent_open): Disable it until we have our AF_UNIX implementation
	ready.
	* fseeko.c, ftello.c: Include sys/types for the sake of W32.

2004-11-23  Werner Koch  <wk@g10code.com>

	* b64enc.c: Include stdio.h and string.h

2004-08-18  Werner Koch  <wk@g10code.de>

	* simple-pwquery.c (simple_pwquery): Handle gpg-error style return
	code for canceled.

2004-07-20  Werner Koch  <wk@g10code.de>

	* maperror.c: Removed header ksba.h.  Not required anymore.

2004-06-14  Werner Koch  <wk@gnupg.org>

	* xreadline.c: New.  Based on the iobuf_read_line function.

2004-05-12  Werner Koch  <wk@gnupg.org>

	* util.h (xtrycalloc_secure,xtrymalloc_secure): New.

2004-05-11  Werner Koch  <wk@gnupg.org>

	* sysutils.c (disable_core_dumps): Only set the current limit.
	(enable_core_dumps): New.

2004-04-13  Werner Koch  <wk@gnupg.org>

	* simple-pwquery.c (copy_and_escape): Relaxed quoting.

2004-04-05  Werner Koch  <wk@gnupg.org>

	* errors.h (STATUS_NEWSIG): New.

2004-03-11  Werner Koch  <wk@gnupg.org>

	* dynload.h [__MINGW32__]: Define RTLD_LAZY.

2004-03-09  Werner Koch  <wk@gnupg.org>

	* maperror.c (map_assuan_err): Map the Locale_Problem item.

2004-03-03  Werner Koch  <wk@gnupg.org>

	* asshelp.c, asshelp.h: New.
	(send_pinentry_environment): New. Code taken from ../sm/call-agent.c.

2004-02-19  Werner Koch  <wk@gnupg.org>

	* simple-pwquery.c (agent_open): Don't mangle INFOSTR.

2004-02-17  Werner Koch  <wk@gnupg.org>

	* simple-pwquery.c (agent_open): Ignore an empty GPG_AGENT_INFO.

	* errors.h: Added STATUS_IMPORT_OK.

2004-02-10  Werner Koch  <wk@gnupg.org>

	* b64enc.c: New.  Based on code from ../sm/base64.c.

2004-01-30  Marcus Brinkmann  <marcus@g10code.de>

	* Makefile.am (libcommon_a_SOURCES): Add xasprintf.c.
	* miscellaneous.c (xasprintf): Moved to ...
	* xasprintf (xasprintf): ... here.  New file.
	This allows to use xasprintf without sucking in gpg-error.

2004-01-27  Werner Koch  <wk@gnupg.org>

	* sexp-parse.h: New; moved from../agent.

	* util.h (xtoi_4): New.

2003-12-23  Werner Koch  <wk@gnupg.org>

	* maperror.c (map_assuan_err): Prepared for a new error code.

2003-12-17  Werner Koch  <wk@gnupg.org>

	* gettime.c (asctimestamp): Add a note on a non-avoidable gcc warning.

	* util.h [!HAVE_VASPRINTF]: Add printf format attribute to the
	replacement function.

	* miscellaneous.c (xasprintf): New.

2003-11-14  Werner Koch  <wk@gnupg.org>

	* mkdtemp.c (mkdtemp): Use gcry_create_nonce.

	* cryptmiss.c: Removed.

2003-11-13  Werner Koch  <wk@gnupg.org>

	* util.h (vasprintf): Also fixed the prototype.

	* vasprintf.c (vasprintf): ARGS should not be a pointer.  Fixed
	segv on Solaris.  Reported by Andrew J. Schorr.

2003-11-12  Werner Koch  <wk@gnupg.org>

	* maperror.c (map_ksba_err, map_gcry_err, map_kbx_err): Removed.

2003-10-31  Werner Koch  <wk@gnupg.org>

	* util.h (gnupg_isotime_t): New.
	(gnupg_copy_time): New.

	* gettime.c (gnupg_get_isotime): New.

2003-09-23  Werner Koch  <wk@gnupg.org>

	* iobuf.c (check_special_filename): Replaced is isdigit by digitp
	to avoid passing negative values and potential locale problems.
	Problem noted by Christian Biere.

	* util.h (ascii_isspace): New.

2003-09-18  Werner Koch  <wk@gnupg.org>

	* ttyio.c (tty_fprintf): New.
	(tty_print_string, tty_print_utf8_string2)
	(tty_print_utf8_string): Made P argument const byte*.

2003-08-20  Marcus Brinkmann  <marcus@g10code.de>

	* maperror.c (map_ksba_err): Map -1.  Use gpg_err_make to set
	the error source.

2003-08-14  Timo Schulz  <twoaday@freakmail.de>

	* dynload.h. New. W32 wrapper around the dynload mechanism.

2003-07-15  Werner Koch  <wk@gnupg.org>

	* simple-pwquery.c, simple-pwquery.h:  New; moved from ../agent.
	* Makefile.am (libsimple_pwquery_a_LIBADD): New.

2003-06-25  Werner Koch  <wk@gnupg.org>

	* maperror.c (map_to_assuan_status): Directly map 0 to 0.

2003-06-17  Werner Koch  <wk@gnupg.org>

	* gettime.c (scan_isodatestr,add_days_to_timestamp,strtimevalue)
	(strtimestamp,asctimestamp): New.  Code taken from gnupg 1.3.2
	mischelp.c.

	* yesno.c: New.  Code taken from gnupg 1.3.2 mischelp.c

	* miscellaneous.c: New.

	* util.h: Include utf8conf.h

2003-06-16  Werner Koch  <wk@gnupg.org>

	* gettime.c (make_timestamp): New.

	* ttyio.c: New. Taken from gnupg 1.2.
	* ttyio.h: Move from ../include.

2003-06-13  Werner Koch  <wk@gnupg.org>

	* util.h (seterr): Removed macro.
	(xmalloc_secure,xcalloc_secure): New.

2003-06-11  Werner Koch  <wk@gnupg.org>

	* iobuf.c (iobuf_writebyte,iobuf_write): Return error code from
	iobuf_flush.
	(iobuf_writestr): Ditto.

2003-06-10  Werner Koch  <wk@gnupg.org>

	* iobuf.c, iobuf.h: New. Taken from current gnupg 1.3 CVS.  Run
	indent on it and adjusted error handling to libgpg-error style.
	Replaced IOBUF by iobuf_t. Renamed malloc functions.

2003-06-04  Werner Koch  <wk@gnupg.org>

	* errors.h: Removed all error codes.  We keep the status codes for
	now.
	* Makefile.am: Do not create errors.c anymore; remove it from the
	sources.

	* maperror.c: Don't include error.h.  Change all error codes to
	libgpg-error style.
	(map_assuan_err): Changed to new Assuan error code convention.
	(map_to_assuan_status): Likewise.
	(map_gcry_err,map_kbx_err): Not needed.  For now dummy functions.

	* membuf.c, membuf.h: New.  Code taken from ../sm/call-agent.h.
	* Makefile.am: Added above.

2003-04-29  Werner Koch  <wk@gnupg.org>

	* util.h (fopencokokie): Removed prototype and struct.

	* fopencookie.c: Removed.

	* maperror.c: Use system assuan.h

2002-10-31  Neal H. Walfield  <neal@g10code.de>

	* isascii.c: New file.
	* putc_unlocked.c: Likewise.

2002-10-28  Neal H. Walfield  <neal@g10code.de>

	* signal.c (caught_fatal_sig): Remove superfluous zero
	initializer.
	(caught_sigusr1): Likewise.

2002-09-04  Neal H. Walfield  <neal@g10code.de>

	* vasprintf.c (vasprintf) [va_copy]: Use va_copy.
	[!va_copy && __va_copy]: Use __va_copy.
	[!va_copy && !__va_copy]: Only now fall back to using memcpy.

2002-08-21  Werner Koch  <wk@gnupg.org>

	* errors.h: Added STATUS_IMPORT_PROBLEM.

2002-08-20  Werner Koch  <wk@gnupg.org>

	* vasprintf.c: Hack to handle NULL for %s.

2002-08-09  Werner Koch  <wk@gnupg.org>

	* signal.c: New. Taken from GnuPG 1.1.91.

2002-07-23  Werner Koch  <wk@gnupg.org>

	* util.h (_IO_cookie_io_functions_t): Fixed typo.  Noted by
	Richard Lefebvre.

2002-07-22  Werner Koch  <wk@gnupg.org>

	* fseeko.c, ftello.c: New.

2002-06-28  Werner Koch  <wk@gnupg.org>

	* maperror.c (map_to_assuan_status): Map more errorcodes to Bad
	Certificate.

2002-06-26  Werner Koch  <wk@gnupg.org>

	* maperror.c (map_to_assuan_status): Map EOF to No_Data_Available.

2002-06-10  Werner Koch  <wk@gnupg.org>

	* errors.h (gnupg_error_token): Add new prototype.
	(STATUS_ERROR): New.

	* mkerrtok: New.
	* Makefile.am: Use it to create the new error token function.

2002-06-04  Werner Koch  <wk@gnupg.org>

	* maperror.c (map_to_assuan_status): Map Bad_CA_Certificate.

2002-05-23  Werner Koch  <wk@gnupg.org>

	* no-pth.c, Makefile.am: Removed.

2002-05-22  Werner Koch  <wk@gnupg.org>

	* mkdtemp.c: Replaced byte by unsigned char because it is no longer
	defined in gcrypt.h.

2002-05-21  Werner Koch  <wk@gnupg.org>

	* maperror.c (map_gcry_err): Add libgcrypt's new S-expression errors.
	(map_ksba_err): Add a few mappings.

2002-05-14  Werner Koch  <wk@gnupg.org>

	* gettime.c: New.

2002-05-03  Werner Koch  <wk@gnupg.org>

	* errors.h: Added STARUS_EXPSIG and STATUS_EXPKEYSIG.

2002-04-15  Werner Koch  <wk@gnupg.org>

	* cryptmiss.c: New.

2002-02-14  Werner Koch  <wk@gnupg.org>

	* maperror.c: Add more assuan<->gnupg mappings.

2002-02-12  Werner Koch  <wk@gnupg.org>

	* fopencookie.c: Dummy function.

	* vasprintf.c: New.  Taken from binutils-2.9.1 and dropped all non
	ANSI-C stuff.  Merged with asprintf version.

	* no-pth.c: New.

2002-01-23  Werner Koch  <wk@gnupg.org>

	* mkdtemp.c: Copied from gnupg-1.0.6c and changed to use libgcrypt.

2002-01-19  Werner Koch  <wk@gnupg.org>

	* sysutils.c: New.  This is the misc.c file from gnupg 1.0.6 with
	the OpenPGP stuff removed.
	* sysutils.h: New.

2002-01-15  Werner Koch  <wk@gnupg.org>

	* maperror.c: Add mapping for Not_Trusted.

2002-01-11  Werner Koch  <wk@gnupg.org>

	* maperror.c (map_assuan_err): Codes for CRL

2002-01-08  Werner Koch  <wk@gnupg.org>

	* util.h (spacep): New.

2002-01-02  Werner Koch  <wk@gnupg.org>

	* maperror.c (map_to_assuan_status): New.  Merged from ../agent
	and ../sm.

2001-12-20  Werner Koch  <wk@gnupg.org>

	* maperror.c (map_gcry_err): Add some mappings.

2001-12-18  Werner Koch  <wk@gnupg.org>

	* Makefile.am (AM_CPPFLAGS): Include flags for gcrypt and ksba

2001-12-14  Werner Koch  <wk@gnupg.org>

	* util.h (digitp, hexdigitp): New ctype like macros.
	(atoi_1,atoi_2,atoi_4,xtoi_1,xtoi_2): New.


 Copyright 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008,
	   2009, 2010, 2011 Free Software Foundation, Inc.

 This file is free software; as a special exception the author gives
 unlimited permission to copy and/or distribute it, with or without
 modifications, as long as this notice is preserved.

 This file is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

Local Variables:
buffer-read-only: t
End:
